

#ifdef WIN32

#include <windows.h>
#include <time.h>

float	g_fStartOfFrame_,
		g_fEndOfFrame_  ,
	    g_frametime     ,
		g_fRateInv_     ;
__int64 StartClk_       ;

/*
 *	Initialise the frame counter
 */
void  InitFrameTime()
{
	__int64 Rate;
	g_fRateInv_ = 1.0f/(float)CLOCKS_PER_SEC;

	if( !QueryPerformanceFrequency( ( LARGE_INTEGER* )&Rate) )
		return;

	if(!Rate)
		return;

	g_fRateInv_=1.0f/(float)Rate;
	if(!QueryPerformanceCounter( ( LARGE_INTEGER* )&StartClk_) )
		return;
}

/*
 *	Get the current time
 */
float CurrentTime()
{
	__int64 EndClk;
	QueryPerformanceCounter(( LARGE_INTEGER* )&EndClk);
	return  ( EndClk - StartClk_ )*g_fRateInv_;
}

/*
 *	Update frame time
 */
void  UpdateFrameTime()
{
	do
	{
		g_fEndOfFrame_=CurrentTime();
	}
	while(g_fEndOfFrame_==g_fStartOfFrame_);

	g_frametime       =  g_fEndOfFrame_ - g_fStartOfFrame_ ;
	g_fStartOfFrame_  =  g_fEndOfFrame_ ;
}

float GetFrameTime()
{
	return g_frametime;
}

#else	/*============================================= Irix frametiming */

#endif